// License: Apache 2.0. See LICENSE file in root directory.
// Copyright(c) 2023 Intel Corporation. All Rights Reserved.

/*!
 * @file ImageTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include <realdds/topics/ros2/ros2image.h>
#include "ros2imageTypeObject.h"
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerImageTypes()
{
    TypeObjectFactory *factory = TypeObjectFactory::get_instance();
    factory->add_type_object("std_msgs::msg::Time", std_msgs::msg::GetTimeIdentifier(true),
            std_msgs::msg::GetTimeObject(true));
    factory->add_type_object("std_msgs::msg::Time", std_msgs::msg::GetTimeIdentifier(false),
            std_msgs::msg::GetTimeObject(false));



    factory->add_type_object("std_msgs::msg::Header", std_msgs::msg::GetHeaderIdentifier(true),
            std_msgs::msg::GetHeaderObject(true));
    factory->add_type_object("std_msgs::msg::Header", std_msgs::msg::GetHeaderIdentifier(false),
            std_msgs::msg::GetHeaderObject(false));



    factory->add_type_object("sensor_msgs::msg::dds_::Image_", sensor_msgs::msg::GetImageIdentifier(true),
            sensor_msgs::msg::GetImageObject(true));
    factory->add_type_object("sensor_msgs::msg::dds_::Image_", sensor_msgs::msg::GetImageIdentifier(false),
            sensor_msgs::msg::GetImageObject(false));



}

namespace sensor_msgs {
    namespace msg {
        const TypeIdentifier* GetImageIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Image", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetImageObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Image", complete);
        }

        const TypeObject* GetImageObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Image", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteImageObject();
            }
            //else
            return GetMinimalImageObject();
        }

        const TypeObject* GetMinimalImageObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Image", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*std_msgs::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_encoding;
            mst_encoding.common().member_id(memberId++);
            mst_encoding.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_encoding.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_encoding.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_encoding.common().member_flags().IS_OPTIONAL(false);
            mst_encoding.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_encoding.common().member_flags().IS_KEY(false);
            mst_encoding.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_encoding.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 encoding_hash("encoding");
            for(int i = 0; i < 4; ++i)
            {
                mst_encoding.detail().name_hash()[i] = encoding_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_encoding);

            MinimalStructMember mst_is_bigendian;
            mst_is_bigendian.common().member_id(memberId++);
            mst_is_bigendian.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_bigendian.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_bigendian.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_bigendian.common().member_flags().IS_OPTIONAL(false);
            mst_is_bigendian.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_bigendian.common().member_flags().IS_KEY(false);
            mst_is_bigendian.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_bigendian.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 is_bigendian_hash("is_bigendian");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_bigendian.detail().name_hash()[i] = is_bigendian_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_bigendian);

            MinimalStructMember mst_step;
            mst_step.common().member_id(memberId++);
            mst_step.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_step.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_step.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_step.common().member_flags().IS_OPTIONAL(false);
            mst_step.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_step.common().member_flags().IS_KEY(false);
            mst_step.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_step.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 step_hash("step");
            for(int i = 0; i < 4; ++i)
            {
                mst_step.detail().name_hash()[i] = step_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_step);

            MinimalStructMember mst_data;
            mst_data.common().member_id(memberId++);
            mst_data.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_data.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_data.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_data.common().member_flags().IS_OPTIONAL(false);
            mst_data.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_data.common().member_flags().IS_KEY(false);
            mst_data.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_data.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("uint8_t", 0, false));


            MD5 data_hash("data");
            for(int i = 0; i < 4; ++i)
            {
                mst_data.detail().name_hash()[i] = data_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_data);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Image", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Image", false);
        }

        const TypeObject* GetCompleteImageObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Image", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*std_msgs::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_encoding;
            cst_encoding.common().member_id(memberId++);
            cst_encoding.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_encoding.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_encoding.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_encoding.common().member_flags().IS_OPTIONAL(false);
            cst_encoding.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_encoding.common().member_flags().IS_KEY(false);
            cst_encoding.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_encoding.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_encoding.detail().name("encoding");

            type_object->complete().struct_type().member_seq().emplace_back(cst_encoding);

            CompleteStructMember cst_is_bigendian;
            cst_is_bigendian.common().member_id(memberId++);
            cst_is_bigendian.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_bigendian.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_bigendian.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_bigendian.common().member_flags().IS_OPTIONAL(false);
            cst_is_bigendian.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_bigendian.common().member_flags().IS_KEY(false);
            cst_is_bigendian.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_bigendian.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_is_bigendian.detail().name("is_bigendian");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_bigendian);

            CompleteStructMember cst_step;
            cst_step.common().member_id(memberId++);
            cst_step.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_step.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_step.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_step.common().member_flags().IS_OPTIONAL(false);
            cst_step.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_step.common().member_flags().IS_KEY(false);
            cst_step.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_step.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_step.detail().name("step");

            type_object->complete().struct_type().member_seq().emplace_back(cst_step);

            CompleteStructMember cst_data;
            cst_data.common().member_id(memberId++);
            cst_data.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_data.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_data.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_data.common().member_flags().IS_OPTIONAL(false);
            cst_data.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_data.common().member_flags().IS_KEY(false);
            cst_data.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_data.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("uint8_t", 0, true));


            cst_data.detail().name("data");

            type_object->complete().struct_type().member_seq().emplace_back(cst_data);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Image");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Image", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Image", true);
        }

    } // namespace msg
} // namespace sensor_msgs
