# Tools for Intel® RealSense™ Camera

1. [RealSense-Viewer](./realsense-viewer) - This application allows you to quickly access your Intel® RealSense™ Depth cameras and modules.  It allows you to view the depth stream, record and playback streams, configure your camera and much more.
2. [Depth Quality Tool](./depth-quality) - Application that calculates and visualizes depth metrics to assess and characterize the quality of the depth data.
3. [Convert Tool](./convert) - Console application for converting ROS-bag files to various formats
4. [Recorder](./recorder) - Simple command line data recorder

### Debug Tools

3. [Enumerate-Devices](./enumerate-devices) - Console application providing information about connected devices
4. [Firmware-Logger](./fw-logger) - Console application for collecting internal camera logs.
5. [Data-Collect](./data-collect) - Console application capable of generating CSV report of frame statistics
6. [Terminal](./terminal) - Troubleshooting tool that sends commands to the camera firmware
7. [ROS Bag Inspector](./rosbag-inspector) - GUI application for inspecting `.bag` files
8. [dds-sniffer](./dds/dds-sniffer) - Console application providing information about active DDS domain entities
